<script setup lang="ts">
import { useProductStore } from '@/stores/product';
import { computed, ref, watchEffect } from 'vue';
import type { VForm } from 'vuetify/components';
const productStore = useProductStore()
const form = ref(false)
const loading = ref(false)
const types = ref('')
const selectedTypes = ref(['H','C','F']);
const refform = ref<VForm | null>(null)

const watchSelectedTypes = () => {
  // เมื่อมีการเลือกหรือยกเลิกค่าใน selectedTypes
  // ค่าใน gType จะถูกอัปเดตเป็น string ที่รวมทุกค่าที่ถูกเลือก
  types.value = selectedTypes.value.join('');
};
watchEffect(watchSelectedTypes);
function setType(){
    selectedTypes.value = ['H','C','F']
}

async function save(){
    let { valid } = await refform.value!.validate()
    if (!valid) return
    productStore.editedProduct.type = types.value
    productStore.save()
    setType()
    
}

</script>
<template>
    <v-row justify="center">
        <v-dialog v-model="productStore.dialog" persistent width="500">
            <v-card>
                <v-card-title>
                    <span class="text-h5">Add Stock Product</span>
                </v-card-title>
                <v-card-text>
                    <v-form ref="refform" v-model="form">
                        <v-container>
                            <v-row>
                                <v-col cols="12" sm="12" md="12" style="padding: 0;">
                                    <v-text-field v-model="productStore.editedProduct.name" :readonly="loading"
                                        :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                        label="Product Name"></v-text-field>
                                </v-col>
                                <v-col cols="12" sm="12" md="12" style="padding: 0;">
                                    <v-combobox label="Category" :items="[1,2,3]"
                                        v-model="productStore.editedProduct.category"></v-combobox>
                                </v-col>
                                <v-col cols="12" sm="12" md="12" v-if="productStore.editedProduct.category==1" style="padding: 0;">
                                    <v-combobox label="Size" :items="['H', 'C', 'F']"
                                        v-model="selectedTypes" multiple :rules="[ (v) => !!v.length || 'Select at least one option']"></v-combobox>
                                </v-col>
                                <v-col cols="12" sm="12" :md="12" style="padding: 0;">
                                    <v-text-field v-model="productStore.editedProduct.price" :readonly="loading"
                                        :rules="[(v) => !!v || 'Field is required',(v) => v>0||'น้อยไปป่าว']" class="mb-2" clearable
                                        label="Price" @keyup.enter="save()"  inputmode="numeric" pattern="[0-9]*" type="number"></v-text-field>
                                </v-col>
                                
                            </v-row>
                        </v-container>
                    </v-form>
                    <small>*indicates required field</small>
                </v-card-text>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue-darken-1" variant="text" @click="productStore.closeDialog(),setType()">
                        Close
                    </v-btn>
                    <v-btn color="blue-darken-1" variant="text" @click="save()">
                        Save
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>